from sqlalchemy import create_engine, MetaData, ForeignKey, Table, Column, Integer, BigInteger, String, Boolean, DateTime, Text

### WARNING: The first column of each table below MUST BE the partition key for the Cassandra table ###
### WARNING: The order of columns much match exactly the column order of the corresponding Snowflake table ###

def get_metadata(schema='cassandra_extract'):
    metadata = MetaData(schema=schema)

    Table('user', metadata,
        Column('key', BigInteger),
        Column('username', String(length=65535)),
        Column("time_created", DateTime),
        Column("email_confirmed_at", DateTime),
        Column("language", String(length=65535)),
        Column("dob", String(length=65535)),
        Column("gender", String(length=65535)),
        Column("ip", String(length=65535)),
        Column("verified", Boolean),
        Column("admin", Boolean),
        Column("enabled", Boolean),
        Column("banned", Boolean),
        Column("deleted", Boolean),
        Column("plus", Boolean),
        Column("rating", Integer),
        Column("founder", Boolean),
        Column("pro_expires", DateTime),
        Column("pro_published", Boolean),
        Column("last_login", DateTime),
        Column("mature", Boolean),
        Column("ban_monetization", Boolean),
        Column("boost_autorotate", Boolean),
        Column("boost_rating", Integer),
        Column("categories", String(length=65535)),
        Column("disabled_boost", Boolean),
        Column("eth_incentive", String),
        Column("eth_wallet", String(length=65535)),
        Column("group_membership", String(length=65535)),
        Column("is_mature", Boolean),
        Column("mature_content", Boolean),
        Column("mature_lock", Boolean),
        Column("mode", Integer),
        Column("monetization_settings", String(length=65535)),
        Column("onboarding_shown", Boolean),
        Column("pinned_posts", String(length=65535)),
        Column("programs", String(length=65535)),
        Column("spam", Boolean),
        Column("tags", String(length=65535)),
        Column("briefdescription", String(length=65535)),
        Column("signupParentId", BigInteger),
        Column("signupPreviousUrl", String(length=65535)),
        Column("extracted_at", DateTime)
    )

    Table("object_image", metadata,
        Column("key", BigInteger),
        Column("filename", String(length=65535)),
        Column("container_guid", BigInteger),
        Column("owner_guid", BigInteger),
        Column("access_id", BigInteger),
        Column("time_created", DateTime),
        Column("time_updated", DateTime),
        Column("time_sent", DateTime),
        Column("super_subtype", String(length=65535)),
        Column("language", String(length=65535)),
        Column("rating", Integer),
        Column("thumbs_up_user_guids", String(length=65535)),
        Column("thumbs_down_user_guids", String(length=65535)),
        Column("hidden", Boolean),
        Column("mature", Boolean),
        Column("nsfw", String(length=65535)),
        Column("nsfw_lock", String(length=65535)),
        Column("boost_rejection_reason", String(length=65535)),
        Column("extracted_at", DateTime)
    )

    Table("object_album", metadata,
        Column("key", BigInteger),
        Column("owner_guid", BigInteger),
        Column("container_guid", BigInteger),
        Column("access_id", BigInteger),
        Column("super_subtype", String(length=65535)),
        Column("enabled", Boolean),
        Column("time_created", DateTime),
        Column("time_updated", DateTime),
        Column("flags", String(length=65535)),
        Column("thumbs_up_user_guids", String(length=65535)),
        Column("thumbs_down_user_guids", String(length=65535)),
        Column("extracted_at", DateTime)
    )

    Table("object_carousel", metadata,
        Column("key", BigInteger),
        Column("owner_guid", BigInteger),
        Column("container_guid", BigInteger),
        Column("access_id", BigInteger),
        Column("enabled", Boolean),
        Column("time_created", DateTime),
        Column("time_updated", DateTime),
        Column("flags", String(length=65535)),
        Column("thumbs_up_user_guids", String(length=65535)),
        Column("thumbs_down_user_guids", String(length=65535)),
        Column("extracted_at", DateTime)
    )

    Table("object_message", metadata,
        Column("key", BigInteger),
        Column("owner_guid", BigInteger),
        Column("container_guid", BigInteger),
        Column("access_id", BigInteger),
        Column("enabled", Boolean),
        Column("time_created", DateTime),
        Column("time_updated", DateTime),
        Column("extracted_at", DateTime)
    )

    Table("activity", metadata,
        Column("key", BigInteger),
        Column("owner_guid", BigInteger),
        Column("container_guid", BigInteger),
        Column("entity_guid", BigInteger),
        Column("access_id", BigInteger),
        Column("time_created", DateTime),
        Column("time_updated", DateTime),
        Column("time_sent", DateTime),
        Column("language", String(length=65535)),
        Column("deleted", Boolean),
        Column("edited", Boolean),
        Column("enabled", Boolean),
        Column("mature", Boolean),
        Column("nsfw", String(length=65535)),
        Column("nsfw_lock", String(length=65535)),
        Column("rating", Integer),
        Column("spam", Boolean),
        Column("title", String(length=65535)),
        Column("blurb", String(length=65535)),
        Column("message", String(length=65535)),
        Column("tags", String(length=65535)),
        Column("boost_rejection_reason", String(length=65535)),
        Column("thumbs_up_user_guids", String(length=65535)),
        Column("thumbs_down_user_guids", String(length=65535)),
        Column("extracted_at", DateTime),
        Column("remind_object", String(length=65535))
    )

    Table("comment", metadata,
        Column("key", BigInteger),
        Column("parent_guid", BigInteger),
        Column("owner_guid", BigInteger),
        Column("container_guid", BigInteger),
        Column("access_id", BigInteger),
        Column("time_created", DateTime),
        Column("time_updated", DateTime),
        Column("mature", Boolean),
        Column("enabled", Boolean),
        Column("deleted", Boolean),
        Column("thumbs_up_user_guids", String(length=65535)),
        Column("thumbs_down_user_guids", String(length=65535)),
        Column("extracted_at", DateTime)
    )

    Table("group", metadata,
        Column("key", BigInteger),
        Column("access_id", BigInteger),
        Column("name", String(length=65535)),
        Column("brief_description", String(length=65535)),
        Column("ownerObj", String(length=65535)),
        Column("owner_guids", String(length=65535)),
        Column("featured", Boolean),
        Column("mature", Boolean),
        Column("membership", Boolean),
        Column("moderated", Boolean),
        Column("nsfw", String(length=65535)),
        Column("nsfw_lock", String(length=65535)),
        Column("rating", BigInteger),
        Column("tags", String(length=65535)),
        Column("conversationDisabled", Boolean),
        Column("time_created", DateTime),
        Column("extracted_at", DateTime)
    )

    Table("notification", metadata,
        Column("key", BigInteger),
        Column("from_guid", BigInteger),
        Column("to_guid", BigInteger),
        Column("object_guid", BigInteger),
        Column("access_id", BigInteger),
        Column("notification_view", String(length=65535)),
        Column("time_created", DateTime),
        Column("time_updated", DateTime),
        Column("enabled", Boolean),
        Column("extracted_at", DateTime)
    )

    Table("unmatched", metadata,
        Column("key", BigInteger),
        Column("attr", String(length=65535)),
        Column("value", String(length=65535)),
        Column("extracted_at", DateTime)
    )

    return metadata
